'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _extends = Object.assign || function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; };

var _slicedToArray = function () { function sliceIterator(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"]) _i["return"](); } finally { if (_d) throw _e; } } return _arr; } return function (arr, i) { if (Array.isArray(arr)) { return arr; } else if (Symbol.iterator in Object(arr)) { return sliceIterator(arr, i); } else { throw new TypeError("Invalid attempt to destructure non-iterable instance"); } }; }();

var _set = require('lodash/set');

var _set2 = _interopRequireDefault(_set);

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _context = require('./context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

var Form = function Form(_ref) {
  var children = _ref.children,
      rules = _ref.rules,
      values = _ref.values,
      onValues = _ref.onValues;

  var _useState = (0, _react.useState)([]),
      _useState2 = _slicedToArray(_useState, 2),
      errors = _useState2[0],
      setErrors = _useState2[1];

  var _useState3 = (0, _react.useState)({}),
      _useState4 = _slicedToArray(_useState3, 2),
      valuesBlurred = _useState4[0],
      setValuesBlurred = _useState4[1];

  return _react2.default.createElement(
    _context.FormContextProvider,
    {
      values: values,
      rules: rules,
      valuesBlurred: valuesBlurred,
      setErrors: setErrors,
      errors: errors,
      updateValue: function updateValue(name, value) {
        var newValues = _extends({}, values);
        (0, _set2.default)(newValues, name, value);
        onValues(newValues);
      },
      hasBlurred: function hasBlurred(name) {
        if (valuesBlurred[name]) return;
        //Store list of values that have been touched, so we can run validation on them now
        setValuesBlurred(_extends({}, valuesBlurred, _defineProperty({}, name, true)));
      }
    },
    children
  );
};

exports.default = Form;