'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _react = require('react');

var _react2 = _interopRequireDefault(_react);

var _validate = require('./validate');

var _validate2 = _interopRequireDefault(_validate);

var _context = require('./context');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

var useSubmit = function useSubmit() {
  var _React$useContext = _react2.default.useContext(_context.FormContext),
      rules = _React$useContext.rules,
      values = _React$useContext.values,
      errors = _React$useContext.errors,
      setErrors = _React$useContext.setErrors;

  var handleSubmit = function handleSubmit(callback) {
    var errors = (0, _validate2.default)({
      values: values,
      rules: rules,
      setErrors: setErrors
    });
    if (!errors.length) callback(values);
  };

  return {
    values: values,
    handleSubmit: handleSubmit,
    canSubmit: !errors.length
  };
};

exports.default = useSubmit;